; GETREADY_1208.a51 	Lab 22, mu3: 	branch conditional on READY flag
;  puts out a display value that is constant till changed by WR key that causes new
;   read of keypad to new display value
	
    $NOSYMBOLS        ; keeps listing short

; default Ride7 path, Mar. 16
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\REG320.INC) 
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\vectors320.INC) 
	  
	STACKSTART EQU 080h	; starts stack just above SFR's

	SOFTFLAG EQU 0h		; this is bit-addressable location (happens to live at byte 20h)
	
	ORG 0					; tells assembler the address at which to place this code
	
	LJMP STARTUP		; 	here code begins--with just a jump to start of
							;   real program.  ALL our programs will start thus							
	ORG 090h				;  ...and here the program starts

	
STARTUP:	MOV SP, #STACKSTART	; init stack pointer
			ACALL PTRINITS	

			CLR A					; clear display value, for predictable startup
			CLR SOFTFLAG		; clear ready flag, first pass
										
GETKEY:	ACALL READYCHECK		; see if it's time to take a new character: PSW.1 is flag to say 'Yes'
			JNB SOFTFLAG,USEOLD	; if not Ready, use the old display value
			CLR SOFTFLAG			; If Ready, clear that flag bit...
			MOVX A, @DPTR		; ...read the keypad
USEOLD:	MOVX @DPTR,A		; and output to display
			SJMP GETKEY						; look for another key...endlessly
	


;----SUBROUTINES-------------------------------------------------------------------				
PTRINITS:	MOV DPTR, #8000h	; "point" to both display (OUT0) and keypad (INO)
			MOV P2, #80h			; for MOVX @Rn operation, this sets the high half
										;  of address as base of I/O (top half of all address space)
			MOV R0, #01h			; low half of address of READY port
			MOV R1, #02h			; low half of address of READY-CLEAR port
			MOVX A, @R1			; send a pulse to clear flop--though it's called an "IN" device
			RET

;-----------------------------			
; READYCHECK subroutine: if Ready, SETS BIT ZERO (at byte 20h)  as FLAG for main pgm (and clears Ready flop) 
			
READYCHECK: PUSH ACC			; save scratch register
			MOVX A, @R0			; get Ready flag			
			JNB ACC.7,NOCHANGE		;  if flag is low, don't bother to clear the flag

CHANGE:	SETB SOFTFLAG			; If Ready, we'll set a flag bit to indicate that
			MOVX A,@R1	; ...and send a pulse to clear flop
				
NOCHANGE:	POP ACC				; restore saved scratch register
			RET
		
	END
